/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "header.h"
#include "mypopupmenu.h"
#include "loadsave.h"
#include "mainwindow.h"
#include "pagechannel.h"
#include "tabwidget.h"
#include "channel.h"
#include "menubar.h"
//Added by qt3to4:
#include <Q3TextStream>

LoadSave::LoadSave(QObject * parent, const char *name):QObject(parent,
							       name),
mainwindow(static_cast < MainWindow * >(parent))
{
    menubar = mainwindow->menubar;
    loadopenstate();
    loadbookmark();
}

LoadSave::~LoadSave()
{
    saveopenstate();
    savebookmark();
}

//-----------------------------------------------------
void
 LoadSave::loadbookmark()
{
    ///assign initial value
    int id = 2;

    QFile fp(QDir::homeDirPath() + "/.qsopcast/bookmark");
    if (fp.open(QIODevice::ReadOnly)) {
	Q3TextStream stream(&fp);
	stream.setEncoding(Q3TextStream::UnicodeUTF8);
	while (!stream.atEnd()) {
	    menubar->bookmark->insertItem(stream.readLine(), id);
	    strlst += menubar->bookmark->text(id);
	    id++;
	}
	fp.close();
    }
}

//-----------------------------------------------------
void LoadSave::savebookmark()
{
    ///test change
    bool flag = FALSE;
    if (strlst.count() == menubar->bookmark->count() - 2) {
	QStringList::Iterator it = strlst.begin();
	int index = 2;
	while (it != strlst.end()) {
	    if (menubar->bookmark->
		text(menubar->bookmark->idAt(index)) != *it) {
		flag = TRUE;
		break;
	    }
	    it++;
	    index++;
	}
    } else
	flag = TRUE;
    ///save bookmark
    if (flag == TRUE) {
	QFile fp(QDir::homeDirPath() + "/.qsopcast/bookmark");
	QDir dir(QDir::homeDirPath() + "/.qsopcast");
	if (!dir.exists())
	    dir.mkdir(QDir::homeDirPath() + "/.qsopcast");
	if (fp.open(QIODevice::WriteOnly)) {
	    Q3TextStream stream(&fp);
	    stream.setEncoding(Q3TextStream::UnicodeUTF8);

	    for (uint index = 2; index < menubar->bookmark->count();
		 index++)
		stream << menubar->bookmark->text(menubar->bookmark->
						  idAt(index)) << endl;

	    fp.close();
	}
    }
}

//-----------------------------------------------------
/*void LoadSave::loadopenstate()
{
    QFile fp(QDir::homeDirPath() + "/.qsopcast/tree");
    if (fp.open(QIODevice::ReadOnly)) {
	::read(fp.handle(), static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen,
	       sizeof(static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen));
	fp.close();
    } else
	::memset(static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen, 0, sizeof(static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen));
}*/

void
LoadSave::loadopenstate ()
{
   QFile fp (QDir::homeDirPath () + "/.qsopcast/tree");
   if (fp.open (IO_ReadOnly)) {
      char value;
      while (::read (fp.handle (), &value, 1)==1)
	 static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen.append (value);
      fp.close ();
   }
}



//-----------------------------------------------------
/*void LoadSave::saveopenstate()
{
    static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->updateopenstate();

    QString data_path = QDir::homeDirPath() + "/.qsopcast/";
    QDir dir(data_path);
    if (!dir.exists())
	dir.mkdir(data_path);
    data_path += "tree";

    QFile fp(data_path);
    if (fp.open(QIODevice::WriteOnly)) {
	::write(fp.handle(), static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen,
		sizeof(static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen));
	fp.close();
    } else
	perror("path to file tree is invalid");
}*/
void
LoadSave::saveopenstate ()
{
   static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->updateOpenState ();

   QString data_path = QDir::homeDirPath () + "/.qsopcast/";
   QDir dir (data_path);
   if (!dir.exists ())
      dir.mkdir (data_path);
   data_path += "tree";

   QFile fp (data_path);
   if (fp.open (IO_WriteOnly)) {
      for (uint i = 0; i < static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen.count (); i++) {
	 char value = *(static_cast<PageChannel*>(mainwindow->tabwidget->widget(0))->channel->stateopen.at (i));
	 ::write (fp.handle (), &value, 1);
      }
      fp.close ();
   }
   else
      perror ("path to file tree is invalid");
}



//-----------------------------------------------------
