/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "header.h"
#include "mainwindow.h"
#include "config.h"
#include "loadsave.h"
#include "channel.h"
#include "mylistitem.h"
#include "tabwidget.h"
#include "menubar.h"
#include "pagechannel.h"
#include <QKeyEvent>
////slots


MainWindow::MainWindow (QWidget * parent, const char *name):
Q3VBox (parent, name)
{
   //menubar
   menubar = new MenuBar (this);

   /////vboxconfig
   vboxconfig = new Config (this);

   ///row
/*    hbox = new QHBox(this);
    ///clock
    labelclock = new QLabel("22:22:22", hbox);
    labelclock->setFixedSize(labelclock->sizeHint());
    labelclock->setText(QTime::currentTime().toString());
*/

   ///row
   tabwidget = new TabWidget (this);
   static_cast < PageChannel * >(tabwidget->widget (0))->editsearch->setFocus ();

////initialization
   loadsave = new LoadSave (this);
}

MainWindow::~MainWindow ()
{
   delete loadsave;
   ///save width and height
   if (!isMaximized ()) {
      QSettings settings;
      settings.writeEntry ("/qsopcast/width", size ().width ());
      settings.writeEntry ("/qsopcast/height", size ().height ());
   }

}

void
MainWindow::keyPressEvent (QKeyEvent * e)
{
   if (e->key () == Qt::Key_Escape) {
      static_cast<PageChannel*>(tabwidget->widget(0))->editsearch->setFocus ();
      static_cast<PageChannel*>(tabwidget->widget(0))->editsearch->clear ();
   }
   else
      Q3HBox::keyPressEvent (e);
}

