/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MYLISTITEM_H
#define MYLISTITEM_H

#include <q3listview.h>

class MyListItem:public Q3ListViewItem {
  public:
    MyListItem(Q3ListView * parent):Q3ListViewItem(parent) {
	bcolor = Qt::white;
	fcolor = Qt::black;
	state = 0;
    }
    MyListItem(Q3ListViewItem * parent):Q3ListViewItem(parent) {
	bcolor = Qt::white;
	fcolor = Qt::black;
	state = 0;
    }
  MyListItem(Q3ListView * parent, Q3ListViewItem * after):Q3ListViewItem(parent, after)
    {
	bcolor = Qt::white;
	fcolor = Qt::black;
	state = 0;
    }
  MyListItem(Q3ListViewItem * parent, Q3ListViewItem * after):Q3ListViewItem(parent, after)
    {
	bcolor = Qt::white;
	fcolor = Qt::black;
	state = 0;
    }

    QColor fcolor;
    QColor bcolor;
    int state;

  private:

    void paintCell(QPainter * p, const QColorGroup & cg,
		   int column, int width, int alignment) {
	QColorGroup _cg(cg);
//    QColor c = _cg.text ();
	_cg.setColor(QColorGroup::Base, bcolor);
	_cg.setColor(QColorGroup::Text, fcolor);

	Q3ListViewItem::paintCell(p, _cg, column, width, alignment);
//    _cg.setColor (QColorGroup::Text, c);
    }

    int compare(int that, int other) const {
	if (that < other)
	    return -1;
	else if (that > other)
	    return 1;
	return 0;
    }
    int compare(Q3ListViewItem * i, int col, bool ascending) const {
	switch (col) {
	case 1:
	case 3:
	case 4:
	case 5:
	case 6:
	case 7:
	    return compare(text(col).toInt(), i->text(col).toInt());
	    default:return Q3ListViewItem::compare(i, col, ascending);
	}
    }
};


#endif
