/* 
*
* Copyright (C) 2007,2010 Wei Lian <lianwei3 at gmail.com>
*
* This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "header.h"
#include "vlcfork.h"
#include "sopfork.h"
#include "config.h"
#include "pageplay.h"
#include "tabwidget.h"
#include "mainwindow.h"
#include "mystatusbar.h"
//#include "sound.h"
#include "utils.h"

VlcFork::VlcFork (TabWidget * tw, QWidget * parent, const char *name):
SopFork (tw, parent, name),
tabwidget (static_cast < TabWidget * >(tw)),
pageplay (static_cast < PagePlay * >(parent))
{
//  printf ("indexof=%d\n", tabwidget->indexOf (pageplay));
  //cope with bug of vlc of failing to open sound device
  //stop all other vlc
  //count() is not correct, which is smaller than true value by 1
  for (int i = 1; i < tabwidget->count (); i++)
    if (tabwidget->tabToolTip (tabwidget->widget (i)) == "vlc")
      if (static_cast < PagePlay * >(tabwidget->widget (i))->vlcfork->isPlaying) {
	static_cast < PagePlay * >(tabwidget->widget (i))->vlcfork->stopPlayer ();
      }
///////////////
  const char *const vlc_args[] = {
    "-I", "dummy",		/* Don't use any interface */
    "--ignore-config",		/* Don't use VLC's config */
    "--plugin-path=/set/your/path/to/libvlc/module/if/you/are/on/windows/or/macosx"
  };

  /* init vlc modules, should be done only once */
  inst = libvlc_new (sizeof (vlc_args) / sizeof (vlc_args[0]), vlc_args);
  mp = libvlc_media_player_new (inst);
  libvlc_media_player_set_xwindow (mp, pageplay->frame->winId ());	// for vlc 1.0 
  libvlc_audio_set_volume (mp, 100);
  ////////////////////
  isPlaying = false;

  //cope with bug of vlc of failing to open sound device
  //start all other vlc
  //count() is not correct, which is smaller than true value by 1
  for (int i = 1; i < tabwidget->count (); i++)
    if (tabwidget->tabToolTip (tabwidget->widget (i)) == "vlc")
      if (!static_cast < PagePlay * >(tabwidget->widget (i))->vlcfork->isPlaying && static_cast < PagePlay * >(tabwidget->widget (i))->vlcfork->snstatus) {
	static_cast < PagePlay * >(tabwidget->widget (i))->vlcfork->forkPlayer ();
      }

}


VlcFork::~VlcFork ()
{
  libvlc_media_player_stop (mp);
  libvlc_media_player_release (mp);
  libvlc_release (inst);
}

void
VlcFork::stopPlayer ()
{
  libvlc_media_player_stop (mp);
  isPlaying = false;
}


////fork new process
bool VlcFork::forkPlayer ()
{

  QString
    url = "http://127.0.0.1:";
  url += outport;
///
  /* Create a new item */
  libvlc_media_t *
    m;
  m = libvlc_media_new_path (inst, url.ascii ());

  libvlc_media_player_set_media (mp, m);

  /* Create a media player playing environement */
//  mp = libvlc_media_player_new_from_media (m, &ex);

  /* No need to keep the media now */
  libvlc_media_release (m);

  /* play the media_player */
  libvlc_media_player_play (mp);

  isPlaying = true;

//  libvlc_audio_set_mute (inst, false, &ex);
  return true;

}



#include <dirent.h>
#include <signal.h>


void
VlcFork::parseStdout ()
{
  QString str = QString (sop->readStdout ());

///launch player
  if (str.contains ("hook_sc") || str.contains ("downloadRate="))
    if (!libvlc_media_player_is_playing (mp)) {
//      printf ("launch player\n");
      if (!forkPlayer ())
	fprintf (stderr, "failed to launch player!\n");
    }


  if (snstatus == 0) {
    if (str.contains ("hook_sc") || str.contains ("downloadRate=")) {
      //create socket
      int sockfd = connect_to_server ("127.0.0.1", atoi (outport));
      if (sockfd < 0) {
	fprintf (stderr, "failed to create socket, return err %d\n", sockfd);
	return;
      }
      ///bind QSocketNotifier to socket
      snstatus = new QSocketNotifier (sockfd, QSocketNotifier::Read, this);
      connect (snstatus, SIGNAL (activated (int)), SLOT (streamReady (int)));
      write (sockfd, "state\ns\n", sizeof ("state\ns\n"));
      write (sockfd, "state\ns\n", sizeof ("state\ns\n"));
    } else if (str.contains ("detect MTU"))
      statusbar->showMessage (tr ("Waiting..."));
  }
}


void
VlcFork::onSopExit ()
{
  stopPlayer ();
  if (forkSop (channelurl, channelname, channeltype)) {
  } else
    fprintf (stderr, "failed to launch sp-sc!\n");
}
